import { createAggregatedClient } from "@smithy/smithy-client";
import { ACMClient } from "./ACMClient";
import { AddTagsToCertificateCommand, } from "./commands/AddTagsToCertificateCommand";
import { DeleteCertificateCommand, } from "./commands/DeleteCertificateCommand";
import { DescribeCertificateCommand, } from "./commands/DescribeCertificateCommand";
import { ExportCertificateCommand, } from "./commands/ExportCertificateCommand";
import { GetAccountConfigurationCommand, } from "./commands/GetAccountConfigurationCommand";
import { GetCertificateCommand, } from "./commands/GetCertificateCommand";
import { ImportCertificateCommand, } from "./commands/ImportCertificateCommand";
import { ListCertificatesCommand, } from "./commands/ListCertificatesCommand";
import { ListTagsForCertificateCommand, } from "./commands/ListTagsForCertificateCommand";
import { PutAccountConfigurationCommand, } from "./commands/PutAccountConfigurationCommand";
import { RemoveTagsFromCertificateCommand, } from "./commands/RemoveTagsFromCertificateCommand";
import { RenewCertificateCommand, } from "./commands/RenewCertificateCommand";
import { RequestCertificateCommand, } from "./commands/RequestCertificateCommand";
import { ResendValidationEmailCommand, } from "./commands/ResendValidationEmailCommand";
import { UpdateCertificateOptionsCommand, } from "./commands/UpdateCertificateOptionsCommand";
const commands = {
    AddTagsToCertificateCommand,
    DeleteCertificateCommand,
    DescribeCertificateCommand,
    ExportCertificateCommand,
    GetAccountConfigurationCommand,
    GetCertificateCommand,
    ImportCertificateCommand,
    ListCertificatesCommand,
    ListTagsForCertificateCommand,
    PutAccountConfigurationCommand,
    RemoveTagsFromCertificateCommand,
    RenewCertificateCommand,
    RequestCertificateCommand,
    ResendValidationEmailCommand,
    UpdateCertificateOptionsCommand,
};
export class ACM extends ACMClient {
}
createAggregatedClient(commands, ACM);
