import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ExportCertificateRequestFilterSensitiveLog, ExportCertificateResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ExportCertificateCommand, se_ExportCertificateCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class ExportCertificateCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CertificateManager", "ExportCertificate", {})
    .n("ACMClient", "ExportCertificateCommand")
    .f(ExportCertificateRequestFilterSensitiveLog, ExportCertificateResponseFilterSensitiveLog)
    .ser(se_ExportCertificateCommand)
    .de(de_ExportCertificateCommand)
    .build() {
}
