import { SENSITIVE_STRING } from "@smithy/smithy-client";
import { ACMServiceException as __BaseException } from "./ACMServiceException";
export class AccessDeniedException extends __BaseException {
    name = "AccessDeniedException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
export class InvalidArnException extends __BaseException {
    name = "InvalidArnException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidArnException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidArnException.prototype);
    }
}
export class InvalidParameterException extends __BaseException {
    name = "InvalidParameterException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidParameterException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidParameterException.prototype);
    }
}
export class InvalidTagException extends __BaseException {
    name = "InvalidTagException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidTagException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidTagException.prototype);
    }
}
export class ResourceNotFoundException extends __BaseException {
    name = "ResourceNotFoundException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
    }
}
export class TagPolicyException extends __BaseException {
    name = "TagPolicyException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "TagPolicyException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, TagPolicyException.prototype);
    }
}
export class ThrottlingException extends __BaseException {
    name = "ThrottlingException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ThrottlingException.prototype);
    }
}
export class TooManyTagsException extends __BaseException {
    name = "TooManyTagsException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "TooManyTagsException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, TooManyTagsException.prototype);
    }
}
export const RecordType = {
    CNAME: "CNAME",
};
export const ValidationMethod = {
    DNS: "DNS",
    EMAIL: "EMAIL",
    HTTP: "HTTP",
};
export const DomainStatus = {
    FAILED: "FAILED",
    PENDING_VALIDATION: "PENDING_VALIDATION",
    SUCCESS: "SUCCESS",
};
export const ExtendedKeyUsageName = {
    ANY: "ANY",
    CODE_SIGNING: "CODE_SIGNING",
    CUSTOM: "CUSTOM",
    EMAIL_PROTECTION: "EMAIL_PROTECTION",
    IPSEC_END_SYSTEM: "IPSEC_END_SYSTEM",
    IPSEC_TUNNEL: "IPSEC_TUNNEL",
    IPSEC_USER: "IPSEC_USER",
    NONE: "NONE",
    OCSP_SIGNING: "OCSP_SIGNING",
    TIME_STAMPING: "TIME_STAMPING",
    TLS_WEB_CLIENT_AUTHENTICATION: "TLS_WEB_CLIENT_AUTHENTICATION",
    TLS_WEB_SERVER_AUTHENTICATION: "TLS_WEB_SERVER_AUTHENTICATION",
};
export const FailureReason = {
    ADDITIONAL_VERIFICATION_REQUIRED: "ADDITIONAL_VERIFICATION_REQUIRED",
    CAA_ERROR: "CAA_ERROR",
    DOMAIN_NOT_ALLOWED: "DOMAIN_NOT_ALLOWED",
    DOMAIN_VALIDATION_DENIED: "DOMAIN_VALIDATION_DENIED",
    INVALID_PUBLIC_DOMAIN: "INVALID_PUBLIC_DOMAIN",
    NO_AVAILABLE_CONTACTS: "NO_AVAILABLE_CONTACTS",
    OTHER: "OTHER",
    PCA_ACCESS_DENIED: "PCA_ACCESS_DENIED",
    PCA_INVALID_ARGS: "PCA_INVALID_ARGS",
    PCA_INVALID_ARN: "PCA_INVALID_ARN",
    PCA_INVALID_DURATION: "PCA_INVALID_DURATION",
    PCA_INVALID_STATE: "PCA_INVALID_STATE",
    PCA_LIMIT_EXCEEDED: "PCA_LIMIT_EXCEEDED",
    PCA_NAME_CONSTRAINTS_VALIDATION: "PCA_NAME_CONSTRAINTS_VALIDATION",
    PCA_REQUEST_FAILED: "PCA_REQUEST_FAILED",
    PCA_RESOURCE_NOT_FOUND: "PCA_RESOURCE_NOT_FOUND",
    SLR_NOT_FOUND: "SLR_NOT_FOUND",
};
export const KeyAlgorithm = {
    EC_prime256v1: "EC_prime256v1",
    EC_secp384r1: "EC_secp384r1",
    EC_secp521r1: "EC_secp521r1",
    RSA_1024: "RSA_1024",
    RSA_2048: "RSA_2048",
    RSA_3072: "RSA_3072",
    RSA_4096: "RSA_4096",
};
export const KeyUsageName = {
    ANY: "ANY",
    CERTIFICATE_SIGNING: "CERTIFICATE_SIGNING",
    CRL_SIGNING: "CRL_SIGNING",
    CUSTOM: "CUSTOM",
    DATA_ENCIPHERMENT: "DATA_ENCIPHERMENT",
    DECIPHER_ONLY: "DECIPHER_ONLY",
    DIGITAL_SIGNATURE: "DIGITAL_SIGNATURE",
    ENCHIPER_ONLY: "ENCIPHER_ONLY",
    KEY_AGREEMENT: "KEY_AGREEMENT",
    KEY_ENCIPHERMENT: "KEY_ENCIPHERMENT",
    NON_REPUDATION: "NON_REPUDIATION",
};
export const CertificateManagedBy = {
    CLOUDFRONT: "CLOUDFRONT",
};
export const CertificateTransparencyLoggingPreference = {
    DISABLED: "DISABLED",
    ENABLED: "ENABLED",
};
export const RenewalEligibility = {
    ELIGIBLE: "ELIGIBLE",
    INELIGIBLE: "INELIGIBLE",
};
export const RenewalStatus = {
    FAILED: "FAILED",
    PENDING_AUTO_RENEWAL: "PENDING_AUTO_RENEWAL",
    PENDING_VALIDATION: "PENDING_VALIDATION",
    SUCCESS: "SUCCESS",
};
export const RevocationReason = {
    AFFILIATION_CHANGED: "AFFILIATION_CHANGED",
    A_A_COMPROMISE: "A_A_COMPROMISE",
    CA_COMPROMISE: "CA_COMPROMISE",
    CERTIFICATE_HOLD: "CERTIFICATE_HOLD",
    CESSATION_OF_OPERATION: "CESSATION_OF_OPERATION",
    KEY_COMPROMISE: "KEY_COMPROMISE",
    PRIVILEGE_WITHDRAWN: "PRIVILEGE_WITHDRAWN",
    REMOVE_FROM_CRL: "REMOVE_FROM_CRL",
    SUPERCEDED: "SUPERCEDED",
    SUPERSEDED: "SUPERSEDED",
    UNSPECIFIED: "UNSPECIFIED",
};
export const CertificateStatus = {
    EXPIRED: "EXPIRED",
    FAILED: "FAILED",
    INACTIVE: "INACTIVE",
    ISSUED: "ISSUED",
    PENDING_VALIDATION: "PENDING_VALIDATION",
    REVOKED: "REVOKED",
    VALIDATION_TIMED_OUT: "VALIDATION_TIMED_OUT",
};
export const CertificateType = {
    AMAZON_ISSUED: "AMAZON_ISSUED",
    IMPORTED: "IMPORTED",
    PRIVATE: "PRIVATE",
};
export class ConflictException extends __BaseException {
    name = "ConflictException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConflictException.prototype);
    }
}
export class ResourceInUseException extends __BaseException {
    name = "ResourceInUseException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ResourceInUseException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceInUseException.prototype);
    }
}
export class RequestInProgressException extends __BaseException {
    name = "RequestInProgressException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "RequestInProgressException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, RequestInProgressException.prototype);
    }
}
export class LimitExceededException extends __BaseException {
    name = "LimitExceededException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, LimitExceededException.prototype);
    }
}
export class InvalidArgsException extends __BaseException {
    name = "InvalidArgsException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidArgsException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidArgsException.prototype);
    }
}
export const SortBy = {
    CREATED_AT: "CREATED_AT",
};
export const SortOrder = {
    ASCENDING: "ASCENDING",
    DESCENDING: "DESCENDING",
};
export class ValidationException extends __BaseException {
    name = "ValidationException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ValidationException.prototype);
    }
}
export class InvalidDomainValidationOptionsException extends __BaseException {
    name = "InvalidDomainValidationOptionsException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidDomainValidationOptionsException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidDomainValidationOptionsException.prototype);
    }
}
export class InvalidStateException extends __BaseException {
    name = "InvalidStateException";
    $fault = "client";
    constructor(opts) {
        super({
            name: "InvalidStateException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidStateException.prototype);
    }
}
export const ExportCertificateRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Passphrase && { Passphrase: SENSITIVE_STRING }),
});
export const ExportCertificateResponseFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.PrivateKey && { PrivateKey: SENSITIVE_STRING }),
});
export const ImportCertificateRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.PrivateKey && { PrivateKey: SENSITIVE_STRING }),
});
