import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { ACMClientResolvedConfig } from "../ACMClient";
export interface ACMHttpAuthSchemeParameters extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ACMHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ACMClientResolvedConfig,
    HandlerExecutionContext,
    ACMHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultACMHttpAuthSchemeParametersProvider: (
  config: ACMClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ACMHttpAuthSchemeParameters>;
export interface ACMHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ACMHttpAuthSchemeParameters> {}
export declare const defaultACMHttpAuthSchemeProvider: ACMHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ACMHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ACMHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
