import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { ACMServiceException as __BaseException } from "./ACMServiceException";
export declare class AccessDeniedException extends __BaseException {
  readonly name: "AccessDeniedException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<AccessDeniedException, __BaseException>
  );
}
export interface Tag {
  Key: string | undefined;
  Value?: string | undefined;
}
export interface AddTagsToCertificateRequest {
  CertificateArn: string | undefined;
  Tags: Tag[] | undefined;
}
export declare class InvalidArnException extends __BaseException {
  readonly name: "InvalidArnException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidArnException, __BaseException>
  );
}
export declare class InvalidParameterException extends __BaseException {
  readonly name: "InvalidParameterException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidParameterException, __BaseException>
  );
}
export declare class InvalidTagException extends __BaseException {
  readonly name: "InvalidTagException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidTagException, __BaseException>
  );
}
export declare class ResourceNotFoundException extends __BaseException {
  readonly name: "ResourceNotFoundException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ResourceNotFoundException, __BaseException>
  );
}
export declare class TagPolicyException extends __BaseException {
  readonly name: "TagPolicyException";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<TagPolicyException, __BaseException>);
}
export declare class ThrottlingException extends __BaseException {
  readonly name: "ThrottlingException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ThrottlingException, __BaseException>
  );
}
export declare class TooManyTagsException extends __BaseException {
  readonly name: "TooManyTagsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<TooManyTagsException, __BaseException>
  );
}
export interface HttpRedirect {
  RedirectFrom?: string | undefined;
  RedirectTo?: string | undefined;
}
export declare const RecordType: {
  readonly CNAME: "CNAME";
};
export type RecordType = (typeof RecordType)[keyof typeof RecordType];
export interface ResourceRecord {
  Name: string | undefined;
  Type: RecordType | undefined;
  Value: string | undefined;
}
export declare const ValidationMethod: {
  readonly DNS: "DNS";
  readonly EMAIL: "EMAIL";
  readonly HTTP: "HTTP";
};
export type ValidationMethod =
  (typeof ValidationMethod)[keyof typeof ValidationMethod];
export declare const DomainStatus: {
  readonly FAILED: "FAILED";
  readonly PENDING_VALIDATION: "PENDING_VALIDATION";
  readonly SUCCESS: "SUCCESS";
};
export type DomainStatus = (typeof DomainStatus)[keyof typeof DomainStatus];
export interface DomainValidation {
  DomainName: string | undefined;
  ValidationEmails?: string[] | undefined;
  ValidationDomain?: string | undefined;
  ValidationStatus?: DomainStatus | undefined;
  ResourceRecord?: ResourceRecord | undefined;
  HttpRedirect?: HttpRedirect | undefined;
  ValidationMethod?: ValidationMethod | undefined;
}
export declare const ExtendedKeyUsageName: {
  readonly ANY: "ANY";
  readonly CODE_SIGNING: "CODE_SIGNING";
  readonly CUSTOM: "CUSTOM";
  readonly EMAIL_PROTECTION: "EMAIL_PROTECTION";
  readonly IPSEC_END_SYSTEM: "IPSEC_END_SYSTEM";
  readonly IPSEC_TUNNEL: "IPSEC_TUNNEL";
  readonly IPSEC_USER: "IPSEC_USER";
  readonly NONE: "NONE";
  readonly OCSP_SIGNING: "OCSP_SIGNING";
  readonly TIME_STAMPING: "TIME_STAMPING";
  readonly TLS_WEB_CLIENT_AUTHENTICATION: "TLS_WEB_CLIENT_AUTHENTICATION";
  readonly TLS_WEB_SERVER_AUTHENTICATION: "TLS_WEB_SERVER_AUTHENTICATION";
};
export type ExtendedKeyUsageName =
  (typeof ExtendedKeyUsageName)[keyof typeof ExtendedKeyUsageName];
export interface ExtendedKeyUsage {
  Name?: ExtendedKeyUsageName | undefined;
  OID?: string | undefined;
}
export declare const FailureReason: {
  readonly ADDITIONAL_VERIFICATION_REQUIRED: "ADDITIONAL_VERIFICATION_REQUIRED";
  readonly CAA_ERROR: "CAA_ERROR";
  readonly DOMAIN_NOT_ALLOWED: "DOMAIN_NOT_ALLOWED";
  readonly DOMAIN_VALIDATION_DENIED: "DOMAIN_VALIDATION_DENIED";
  readonly INVALID_PUBLIC_DOMAIN: "INVALID_PUBLIC_DOMAIN";
  readonly NO_AVAILABLE_CONTACTS: "NO_AVAILABLE_CONTACTS";
  readonly OTHER: "OTHER";
  readonly PCA_ACCESS_DENIED: "PCA_ACCESS_DENIED";
  readonly PCA_INVALID_ARGS: "PCA_INVALID_ARGS";
  readonly PCA_INVALID_ARN: "PCA_INVALID_ARN";
  readonly PCA_INVALID_DURATION: "PCA_INVALID_DURATION";
  readonly PCA_INVALID_STATE: "PCA_INVALID_STATE";
  readonly PCA_LIMIT_EXCEEDED: "PCA_LIMIT_EXCEEDED";
  readonly PCA_NAME_CONSTRAINTS_VALIDATION: "PCA_NAME_CONSTRAINTS_VALIDATION";
  readonly PCA_REQUEST_FAILED: "PCA_REQUEST_FAILED";
  readonly PCA_RESOURCE_NOT_FOUND: "PCA_RESOURCE_NOT_FOUND";
  readonly SLR_NOT_FOUND: "SLR_NOT_FOUND";
};
export type FailureReason = (typeof FailureReason)[keyof typeof FailureReason];
export declare const KeyAlgorithm: {
  readonly EC_prime256v1: "EC_prime256v1";
  readonly EC_secp384r1: "EC_secp384r1";
  readonly EC_secp521r1: "EC_secp521r1";
  readonly RSA_1024: "RSA_1024";
  readonly RSA_2048: "RSA_2048";
  readonly RSA_3072: "RSA_3072";
  readonly RSA_4096: "RSA_4096";
};
export type KeyAlgorithm = (typeof KeyAlgorithm)[keyof typeof KeyAlgorithm];
export declare const KeyUsageName: {
  readonly ANY: "ANY";
  readonly CERTIFICATE_SIGNING: "CERTIFICATE_SIGNING";
  readonly CRL_SIGNING: "CRL_SIGNING";
  readonly CUSTOM: "CUSTOM";
  readonly DATA_ENCIPHERMENT: "DATA_ENCIPHERMENT";
  readonly DECIPHER_ONLY: "DECIPHER_ONLY";
  readonly DIGITAL_SIGNATURE: "DIGITAL_SIGNATURE";
  readonly ENCHIPER_ONLY: "ENCIPHER_ONLY";
  readonly KEY_AGREEMENT: "KEY_AGREEMENT";
  readonly KEY_ENCIPHERMENT: "KEY_ENCIPHERMENT";
  readonly NON_REPUDATION: "NON_REPUDIATION";
};
export type KeyUsageName = (typeof KeyUsageName)[keyof typeof KeyUsageName];
export interface KeyUsage {
  Name?: KeyUsageName | undefined;
}
export declare const CertificateManagedBy: {
  readonly CLOUDFRONT: "CLOUDFRONT";
};
export type CertificateManagedBy =
  (typeof CertificateManagedBy)[keyof typeof CertificateManagedBy];
export declare const CertificateTransparencyLoggingPreference: {
  readonly DISABLED: "DISABLED";
  readonly ENABLED: "ENABLED";
};
export type CertificateTransparencyLoggingPreference =
  (typeof CertificateTransparencyLoggingPreference)[keyof typeof CertificateTransparencyLoggingPreference];
export interface CertificateOptions {
  CertificateTransparencyLoggingPreference?:
    | CertificateTransparencyLoggingPreference
    | undefined;
}
export declare const RenewalEligibility: {
  readonly ELIGIBLE: "ELIGIBLE";
  readonly INELIGIBLE: "INELIGIBLE";
};
export type RenewalEligibility =
  (typeof RenewalEligibility)[keyof typeof RenewalEligibility];
export declare const RenewalStatus: {
  readonly FAILED: "FAILED";
  readonly PENDING_AUTO_RENEWAL: "PENDING_AUTO_RENEWAL";
  readonly PENDING_VALIDATION: "PENDING_VALIDATION";
  readonly SUCCESS: "SUCCESS";
};
export type RenewalStatus = (typeof RenewalStatus)[keyof typeof RenewalStatus];
export interface RenewalSummary {
  RenewalStatus: RenewalStatus | undefined;
  DomainValidationOptions: DomainValidation[] | undefined;
  RenewalStatusReason?: FailureReason | undefined;
  UpdatedAt: Date | undefined;
}
export declare const RevocationReason: {
  readonly AFFILIATION_CHANGED: "AFFILIATION_CHANGED";
  readonly A_A_COMPROMISE: "A_A_COMPROMISE";
  readonly CA_COMPROMISE: "CA_COMPROMISE";
  readonly CERTIFICATE_HOLD: "CERTIFICATE_HOLD";
  readonly CESSATION_OF_OPERATION: "CESSATION_OF_OPERATION";
  readonly KEY_COMPROMISE: "KEY_COMPROMISE";
  readonly PRIVILEGE_WITHDRAWN: "PRIVILEGE_WITHDRAWN";
  readonly REMOVE_FROM_CRL: "REMOVE_FROM_CRL";
  readonly SUPERCEDED: "SUPERCEDED";
  readonly SUPERSEDED: "SUPERSEDED";
  readonly UNSPECIFIED: "UNSPECIFIED";
};
export type RevocationReason =
  (typeof RevocationReason)[keyof typeof RevocationReason];
export declare const CertificateStatus: {
  readonly EXPIRED: "EXPIRED";
  readonly FAILED: "FAILED";
  readonly INACTIVE: "INACTIVE";
  readonly ISSUED: "ISSUED";
  readonly PENDING_VALIDATION: "PENDING_VALIDATION";
  readonly REVOKED: "REVOKED";
  readonly VALIDATION_TIMED_OUT: "VALIDATION_TIMED_OUT";
};
export type CertificateStatus =
  (typeof CertificateStatus)[keyof typeof CertificateStatus];
export declare const CertificateType: {
  readonly AMAZON_ISSUED: "AMAZON_ISSUED";
  readonly IMPORTED: "IMPORTED";
  readonly PRIVATE: "PRIVATE";
};
export type CertificateType =
  (typeof CertificateType)[keyof typeof CertificateType];
export interface CertificateDetail {
  CertificateArn?: string | undefined;
  DomainName?: string | undefined;
  SubjectAlternativeNames?: string[] | undefined;
  ManagedBy?: CertificateManagedBy | undefined;
  DomainValidationOptions?: DomainValidation[] | undefined;
  Serial?: string | undefined;
  Subject?: string | undefined;
  Issuer?: string | undefined;
  CreatedAt?: Date | undefined;
  IssuedAt?: Date | undefined;
  ImportedAt?: Date | undefined;
  Status?: CertificateStatus | undefined;
  RevokedAt?: Date | undefined;
  RevocationReason?: RevocationReason | undefined;
  NotBefore?: Date | undefined;
  NotAfter?: Date | undefined;
  KeyAlgorithm?: KeyAlgorithm | undefined;
  SignatureAlgorithm?: string | undefined;
  InUseBy?: string[] | undefined;
  FailureReason?: FailureReason | undefined;
  Type?: CertificateType | undefined;
  RenewalSummary?: RenewalSummary | undefined;
  KeyUsages?: KeyUsage[] | undefined;
  ExtendedKeyUsages?: ExtendedKeyUsage[] | undefined;
  CertificateAuthorityArn?: string | undefined;
  RenewalEligibility?: RenewalEligibility | undefined;
  Options?: CertificateOptions | undefined;
}
export declare class ConflictException extends __BaseException {
  readonly name: "ConflictException";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<ConflictException, __BaseException>);
}
export interface DeleteCertificateRequest {
  CertificateArn: string | undefined;
}
export declare class ResourceInUseException extends __BaseException {
  readonly name: "ResourceInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ResourceInUseException, __BaseException>
  );
}
export interface DescribeCertificateRequest {
  CertificateArn: string | undefined;
}
export interface DescribeCertificateResponse {
  Certificate?: CertificateDetail | undefined;
}
export interface ExportCertificateRequest {
  CertificateArn: string | undefined;
  Passphrase: Uint8Array | undefined;
}
export interface ExportCertificateResponse {
  Certificate?: string | undefined;
  CertificateChain?: string | undefined;
  PrivateKey?: string | undefined;
}
export declare class RequestInProgressException extends __BaseException {
  readonly name: "RequestInProgressException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<RequestInProgressException, __BaseException>
  );
}
export interface ExpiryEventsConfiguration {
  DaysBeforeExpiry?: number | undefined;
}
export interface GetAccountConfigurationResponse {
  ExpiryEvents?: ExpiryEventsConfiguration | undefined;
}
export interface GetCertificateRequest {
  CertificateArn: string | undefined;
}
export interface GetCertificateResponse {
  Certificate?: string | undefined;
  CertificateChain?: string | undefined;
}
export interface ImportCertificateRequest {
  CertificateArn?: string | undefined;
  Certificate: Uint8Array | undefined;
  PrivateKey: Uint8Array | undefined;
  CertificateChain?: Uint8Array | undefined;
  Tags?: Tag[] | undefined;
}
export interface ImportCertificateResponse {
  CertificateArn?: string | undefined;
}
export declare class LimitExceededException extends __BaseException {
  readonly name: "LimitExceededException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<LimitExceededException, __BaseException>
  );
}
export declare class InvalidArgsException extends __BaseException {
  readonly name: "InvalidArgsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidArgsException, __BaseException>
  );
}
export interface Filters {
  extendedKeyUsage?: ExtendedKeyUsageName[] | undefined;
  keyUsage?: KeyUsageName[] | undefined;
  keyTypes?: KeyAlgorithm[] | undefined;
  managedBy?: CertificateManagedBy | undefined;
}
export declare const SortBy: {
  readonly CREATED_AT: "CREATED_AT";
};
export type SortBy = (typeof SortBy)[keyof typeof SortBy];
export declare const SortOrder: {
  readonly ASCENDING: "ASCENDING";
  readonly DESCENDING: "DESCENDING";
};
export type SortOrder = (typeof SortOrder)[keyof typeof SortOrder];
export interface ListCertificatesRequest {
  CertificateStatuses?: CertificateStatus[] | undefined;
  Includes?: Filters | undefined;
  NextToken?: string | undefined;
  MaxItems?: number | undefined;
  SortBy?: SortBy | undefined;
  SortOrder?: SortOrder | undefined;
}
export interface CertificateSummary {
  CertificateArn?: string | undefined;
  DomainName?: string | undefined;
  SubjectAlternativeNameSummaries?: string[] | undefined;
  HasAdditionalSubjectAlternativeNames?: boolean | undefined;
  Status?: CertificateStatus | undefined;
  Type?: CertificateType | undefined;
  KeyAlgorithm?: KeyAlgorithm | undefined;
  KeyUsages?: KeyUsageName[] | undefined;
  ExtendedKeyUsages?: ExtendedKeyUsageName[] | undefined;
  InUse?: boolean | undefined;
  Exported?: boolean | undefined;
  RenewalEligibility?: RenewalEligibility | undefined;
  NotBefore?: Date | undefined;
  NotAfter?: Date | undefined;
  CreatedAt?: Date | undefined;
  IssuedAt?: Date | undefined;
  ImportedAt?: Date | undefined;
  RevokedAt?: Date | undefined;
  ManagedBy?: CertificateManagedBy | undefined;
}
export interface ListCertificatesResponse {
  NextToken?: string | undefined;
  CertificateSummaryList?: CertificateSummary[] | undefined;
}
export declare class ValidationException extends __BaseException {
  readonly name: "ValidationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ValidationException, __BaseException>
  );
}
export interface ListTagsForCertificateRequest {
  CertificateArn: string | undefined;
}
export interface ListTagsForCertificateResponse {
  Tags?: Tag[] | undefined;
}
export interface PutAccountConfigurationRequest {
  ExpiryEvents?: ExpiryEventsConfiguration | undefined;
  IdempotencyToken: string | undefined;
}
export interface RemoveTagsFromCertificateRequest {
  CertificateArn: string | undefined;
  Tags: Tag[] | undefined;
}
export interface RenewCertificateRequest {
  CertificateArn: string | undefined;
}
export declare class InvalidDomainValidationOptionsException extends __BaseException {
  readonly name: "InvalidDomainValidationOptionsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidDomainValidationOptionsException,
      __BaseException
    >
  );
}
export interface DomainValidationOption {
  DomainName: string | undefined;
  ValidationDomain: string | undefined;
}
export interface RequestCertificateRequest {
  DomainName: string | undefined;
  ValidationMethod?: ValidationMethod | undefined;
  SubjectAlternativeNames?: string[] | undefined;
  IdempotencyToken?: string | undefined;
  DomainValidationOptions?: DomainValidationOption[] | undefined;
  Options?: CertificateOptions | undefined;
  CertificateAuthorityArn?: string | undefined;
  Tags?: Tag[] | undefined;
  KeyAlgorithm?: KeyAlgorithm | undefined;
  ManagedBy?: CertificateManagedBy | undefined;
}
export interface RequestCertificateResponse {
  CertificateArn?: string | undefined;
}
export declare class InvalidStateException extends __BaseException {
  readonly name: "InvalidStateException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidStateException, __BaseException>
  );
}
export interface ResendValidationEmailRequest {
  CertificateArn: string | undefined;
  Domain: string | undefined;
  ValidationDomain: string | undefined;
}
export interface UpdateCertificateOptionsRequest {
  CertificateArn: string | undefined;
  Options: CertificateOptions | undefined;
}
export declare const ExportCertificateRequestFilterSensitiveLog: (
  obj: ExportCertificateRequest
) => any;
export declare const ExportCertificateResponseFilterSensitiveLog: (
  obj: ExportCertificateResponse
) => any;
export declare const ImportCertificateRequestFilterSensitiveLog: (
  obj: ImportCertificateRequest
) => any;
