import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  AddTagsToCertificateCommandInput,
  AddTagsToCertificateCommandOutput,
} from "../commands/AddTagsToCertificateCommand";
import {
  DeleteCertificateCommandInput,
  DeleteCertificateCommandOutput,
} from "../commands/DeleteCertificateCommand";
import {
  DescribeCertificateCommandInput,
  DescribeCertificateCommandOutput,
} from "../commands/DescribeCertificateCommand";
import {
  ExportCertificateCommandInput,
  ExportCertificateCommandOutput,
} from "../commands/ExportCertificateCommand";
import {
  GetAccountConfigurationCommandInput,
  GetAccountConfigurationCommandOutput,
} from "../commands/GetAccountConfigurationCommand";
import {
  GetCertificateCommandInput,
  GetCertificateCommandOutput,
} from "../commands/GetCertificateCommand";
import {
  ImportCertificateCommandInput,
  ImportCertificateCommandOutput,
} from "../commands/ImportCertificateCommand";
import {
  ListCertificatesCommandInput,
  ListCertificatesCommandOutput,
} from "../commands/ListCertificatesCommand";
import {
  ListTagsForCertificateCommandInput,
  ListTagsForCertificateCommandOutput,
} from "../commands/ListTagsForCertificateCommand";
import {
  PutAccountConfigurationCommandInput,
  PutAccountConfigurationCommandOutput,
} from "../commands/PutAccountConfigurationCommand";
import {
  RemoveTagsFromCertificateCommandInput,
  RemoveTagsFromCertificateCommandOutput,
} from "../commands/RemoveTagsFromCertificateCommand";
import {
  RenewCertificateCommandInput,
  RenewCertificateCommandOutput,
} from "../commands/RenewCertificateCommand";
import {
  RequestCertificateCommandInput,
  RequestCertificateCommandOutput,
} from "../commands/RequestCertificateCommand";
import {
  ResendValidationEmailCommandInput,
  ResendValidationEmailCommandOutput,
} from "../commands/ResendValidationEmailCommand";
import {
  UpdateCertificateOptionsCommandInput,
  UpdateCertificateOptionsCommandOutput,
} from "../commands/UpdateCertificateOptionsCommand";
export declare const se_AddTagsToCertificateCommand: (
  input: AddTagsToCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteCertificateCommand: (
  input: DeleteCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeCertificateCommand: (
  input: DescribeCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ExportCertificateCommand: (
  input: ExportCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAccountConfigurationCommand: (
  input: GetAccountConfigurationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetCertificateCommand: (
  input: GetCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ImportCertificateCommand: (
  input: ImportCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListCertificatesCommand: (
  input: ListCertificatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForCertificateCommand: (
  input: ListTagsForCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutAccountConfigurationCommand: (
  input: PutAccountConfigurationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_RemoveTagsFromCertificateCommand: (
  input: RemoveTagsFromCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_RenewCertificateCommand: (
  input: RenewCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_RequestCertificateCommand: (
  input: RequestCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ResendValidationEmailCommand: (
  input: ResendValidationEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateCertificateOptionsCommand: (
  input: UpdateCertificateOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_AddTagsToCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<AddTagsToCertificateCommandOutput>;
export declare const de_DeleteCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteCertificateCommandOutput>;
export declare const de_DescribeCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeCertificateCommandOutput>;
export declare const de_ExportCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ExportCertificateCommandOutput>;
export declare const de_GetAccountConfigurationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAccountConfigurationCommandOutput>;
export declare const de_GetCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetCertificateCommandOutput>;
export declare const de_ImportCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ImportCertificateCommandOutput>;
export declare const de_ListCertificatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListCertificatesCommandOutput>;
export declare const de_ListTagsForCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForCertificateCommandOutput>;
export declare const de_PutAccountConfigurationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutAccountConfigurationCommandOutput>;
export declare const de_RemoveTagsFromCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RemoveTagsFromCertificateCommandOutput>;
export declare const de_RenewCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RenewCertificateCommandOutput>;
export declare const de_RequestCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RequestCertificateCommandOutput>;
export declare const de_ResendValidationEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ResendValidationEmailCommandOutput>;
export declare const de_UpdateCertificateOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateCertificateOptionsCommandOutput>;
